/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package view;

import dao.CargoDao;
import dao.ClienteDao;
import dao.Conexao;
import dao.ServicoDao;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import model.Cargo;
import model.Cliente;
import model.Servico;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class ViewPrincipal extends javax.swing.JFrame {

    /**
     * Creates new form viewPrincipal
     */
    public ViewPrincipal() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        btMysqlImportar = new javax.swing.JButton();
        btMysqlExportar = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        btSqliteImportar = new javax.swing.JButton();
        btSqliteExportar = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        tfArquivo = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Home");
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "MYSQL"));

        btMysqlImportar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/import.png"))); // NOI18N
        btMysqlImportar.setText("Importar");
        btMysqlImportar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btMysqlImportarActionPerformed(evt);
            }
        });

        btMysqlExportar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/export.png"))); // NOI18N
        btMysqlExportar.setText("Exportar");
        btMysqlExportar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btMysqlExportarActionPerformed(evt);
            }
        });

        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/mysqlLogo.png"))); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(btMysqlImportar)
                .addGap(18, 18, 18)
                .addComponent(btMysqlExportar)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel2)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(btMysqlImportar)
                        .addComponent(btMysqlExportar)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "SQLite"));

        btSqliteImportar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/import.png"))); // NOI18N
        btSqliteImportar.setText("Importar");
        btSqliteImportar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btSqliteImportarActionPerformed(evt);
            }
        });

        btSqliteExportar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/export.png"))); // NOI18N
        btSqliteExportar.setText("Exportar");
        btSqliteExportar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btSqliteExportarActionPerformed(evt);
            }
        });

        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/Sqlite-square-icon.svg.png"))); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 35, Short.MAX_VALUE)
                .addComponent(btSqliteImportar)
                .addGap(18, 18, 18)
                .addComponent(btSqliteExportar)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(btSqliteImportar)
                        .addComponent(btSqliteExportar))
                    .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 13)); // NOI18N
        jLabel1.setText("Arquivo:");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(tfArquivo)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(tfArquivo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addGap(18, 18, 18)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btMysqlImportarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btMysqlImportarActionPerformed
        importar(Conexao.MYSQL);
    }//GEN-LAST:event_btMysqlImportarActionPerformed

    private void btSqliteImportarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btSqliteImportarActionPerformed
       importar(Conexao.SQLITE);
    }//GEN-LAST:event_btSqliteImportarActionPerformed

    private void btMysqlExportarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btMysqlExportarActionPerformed
        exportar(Conexao.MYSQL);
    }//GEN-LAST:event_btMysqlExportarActionPerformed

    private void btSqliteExportarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btSqliteExportarActionPerformed
        exportar(Conexao.SQLITE);
    }//GEN-LAST:event_btSqliteExportarActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]){
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ViewPrincipal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ViewPrincipal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ViewPrincipal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ViewPrincipal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ViewPrincipal().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btMysqlExportar;
    private javax.swing.JButton btMysqlImportar;
    private javax.swing.JButton btSqliteExportar;
    private javax.swing.JButton btSqliteImportar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField tfArquivo;
    // End of variables declaration//GEN-END:variables

    private void importar(int banco){
        
         if(tfArquivo.getText().equals("")){
            JOptionPane.showMessageDialog(null, "Insira o caminho do arquivo a ser importado");
            tfArquivo.requestFocus();
            return;
        }
         
         
        
        try {
            String log = importarXML(tfArquivo.getText(),banco);
            new ViewLog(log).setVisible(true);
        }catch(java.io.FileNotFoundException e){
            JOptionPane.showMessageDialog(null, "Arquivo ou diretório inexistente");
        }catch(org.xml.sax.SAXParseException e){
            JOptionPane.showMessageDialog(null, "O arquivo não um arquivo xml válido!");
        }catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex);
        }
    }
    
    private void exportar(int banco){
         if(tfArquivo.getText().equals("")){
            JOptionPane.showMessageDialog(null, "Insira o caminho do arquivo a ser exportado");
            tfArquivo.requestFocus();
            return;
        }
         
        
        
        try {
            File f = new File(tfArquivo.getText());
            if(f.exists()){
                int operacao = JOptionPane.showConfirmDialog(null, "Arquivo já existe. Deseja sobrescrever o arquivo?","Arquivo Existente",JOptionPane.YES_NO_OPTION);
                if(operacao == JOptionPane.NO_OPTION)
                    return;
            }
            BufferedWriter arqEscrita = new BufferedWriter(new FileWriter(tfArquivo.getText()));
            String xml = gerarXML(tfArquivo.getText(),banco);
            arqEscrita.write(xml);
            new ViewLog(xml).setVisible(true);
            arqEscrita.close();
        }catch(java.io.FileNotFoundException e){
            JOptionPane.showMessageDialog(null, "Arquivo ou diretório inexistente");
        }catch(org.xml.sax.SAXParseException e){
            JOptionPane.showMessageDialog(null, "O arquivo não um arquivo xml válido!");
        }catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex);
        }
    }
    
    private String gerarXML(String arq, int banco) throws Exception{
        
        
        String xml = "";
        ArrayList<Cargo> cargos;
        ArrayList<Cliente> clientes;
        ArrayList<Servico> servicos;
        
        try{
            cargos = new CargoDao(banco).todosCargos();
            clientes = new ClienteDao(banco).todosClientes();
            servicos = new ServicoDao(banco).todosServicos();
        }catch(Exception e){
            throw e;
        }
        
        xml += "<salao>\n";
        
        //Cargos
        xml += "\t<cargos>\n";
        if(cargos != null && !cargos.isEmpty())
            for(Cargo c : cargos)
                xml += c.getXML();
        
        xml += "\t</cargos>\n";
        
        //Clientes
        xml += "\t<clientes>\n";
        
        if(clientes != null && !clientes.isEmpty())
            for(Cliente c : clientes)
                xml += c.getXML();
        
        xml += "\t</clientes>\n";
        
        //Servicos
        xml += "\t<servicos>\n";
        
        if(servicos != null && !servicos.isEmpty())
            for(Servico s : servicos)
                xml += s.getXML();
        
        xml += "\t</servicos>\n";


        xml += "</salao>\n";

        
        return xml;
    }
    private String importarXML(String arq, int banco) throws Exception{
        DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
        Document doc = dBuilder.parse(new File(arq));
        String log = "";

        
        // -------------------------------------------------------------------------------
        // IMPORTAR CARGO
        NodeList nList = doc.getElementsByTagName("cargo");
        Cargo novoCargo = new Cargo();
        for (int i = 0; i < nList.getLength(); i++) {
                Node nNode = nList.item(i);
                //System.out.print("\nElemento corrente : " + nNode.getNodeName());
                if (nNode.getNodeType() != Node.ELEMENT_NODE)
                    continue;
                 
                Element eElement = (Element) nNode;
                // --------------------------------------------
                // ######## CARGO ###########
                try{
                    novoCargo.setIdCargo(Integer.parseInt(eElement.getElementsByTagName("id").item(0).getTextContent()));
                    novoCargo.setDescricao(eElement.getElementsByTagName("descricao").item(0).getTextContent());
                    novoCargo.setSalario(Double.parseDouble(eElement.getElementsByTagName("salario").item(0).getTextContent()));
                }catch(NumberFormatException nfe){
                    JOptionPane.showMessageDialog(null, "Elemento Cargo possui algum dado inválido");
                    continue;
                }catch(NullPointerException npe){
                    
                }
                
                // INSERIR
                if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("i")){
                    try{
                        new CargoDao(banco).salvar(novoCargo);
                        log += "Cargo inserido!\n"+novoCargo.toString()+"\n\n";
                    }catch(java.sql.SQLIntegrityConstraintViolationException e){
                        log += "Cargo não inserido: Já exite Cargo com id = "+novoCargo.getIdCargo()+"\n"+novoCargo.toString()+"\n\n";
                    }catch(java.sql.SQLException e){
                        log += "Cargo não inserido: "+e+"\n"+novoCargo.toString()+"\n\n";
                    }
                }
                //ATUALIZAR
                else if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("a")){
                    try{
                        if(new CargoDao(banco).isCargoExiste(novoCargo.getIdCargo())){
                            new CargoDao(banco).atualizar(novoCargo);
                            log += "Cargo atualizado!\n"+novoCargo.toString()+"\n\n";
                        }else{
                            log += "Cargo não atualizado: Não existe Cargo com este id nesta base de dados\n"+novoCargo.toString()+"\n\n";
                        }
                    }catch(java.sql.SQLException e){
                        log += "Cargo não atualizado: "+e+"\n"+novoCargo.toString()+"\n\n";
                    }
                }
                // REMOVER
                else if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("r")){
                    try{
                        if(new CargoDao(banco).isCargoExiste(novoCargo.getIdCargo())){
                            new CargoDao(banco).excluir(novoCargo);
                            log += "Cargo removido!\nCargo{idCargo = "+novoCargo.getIdCargo()+"}\n\n"; // ???
                            // Verifica apenas o ID para remover, para não aparecer dados incoerentes, exibi apenas o ID
                            // Remover id = 1 com nome = Bob, Mas na base de dados o id = 1 é João. Remove mesmo assim o João
                        }else{
                            log += "Cargo não removido: Não existe Cargo com este id nesta base de dados\n"+novoCargo.toString()+"\n\n";
                        }
                    }catch(java.sql.SQLException e){
                        log += "Cargo não removido: "+e+"\n"+novoCargo.toString()+"\n\n";
                    }
                }
                // LER
                else if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("l")){
                    log += "Cargo Lido!\n"+novoCargo.toString()+"\n\n";
                }
        }
        
        // -------------------------------------------------------------------------------
        // ######## CLIENTE ###########
        nList = doc.getElementsByTagName("cliente");
        Cliente novoCliente = new Cliente();
        for (int i = 0; i < nList.getLength(); i++) {
                Node nNode = nList.item(i);
                //System.out.print("\nElemento corrente : " + nNode.getNodeName());
                if (nNode.getNodeType() != Node.ELEMENT_NODE)
                    continue;
                 
                Element eElement = (Element) nNode;
                // LER DADOS DO CLIENTE
                try{
                    novoCliente.setIdCliente(Integer.parseInt(eElement.getElementsByTagName("id").item(0).getTextContent()));
                    novoCliente.setNome(eElement.getElementsByTagName("nome").item(0).getTextContent());
                    novoCliente.setCpf(eElement.getElementsByTagName("cpf").item(0).getTextContent());
                    novoCliente.setTelefone(eElement.getElementsByTagName("telefone").item(0).getTextContent());
                    novoCliente.setIdade(Integer.parseInt(eElement.getElementsByTagName("idade").item(0).getTextContent()));
                    novoCliente.setSexo(eElement.getElementsByTagName("sexo").item(0).getTextContent());
                }catch(NumberFormatException nfe){
                    JOptionPane.showMessageDialog(null, "Elemento Cliente possui algum dado inválido");
                    continue;
                }catch(NullPointerException npe){
                    
                }
                
                // INSERIR
                if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("i")){
                    try{
                        new ClienteDao(banco).salvar(novoCliente);
                        log += "Cliente inserido!\n"+novoCliente.toString()+"\n\n";
                    }catch(java.sql.SQLIntegrityConstraintViolationException e){
                        log += "Cliente não inserido: Já exite Cliente com id = "+novoCliente.getIdCliente()+"\n"+novoCliente.toString()+"\n\n";
                    }catch(java.sql.SQLException e){
                        log += "Cliente não inserido: "+e+"\n"+novoCliente.toString()+"\n\n";
                    }
                }
                //ATUALIZAR
                else if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("a")){
                    try{
                        if(new ClienteDao(banco).isClienteExiste(novoCliente.getIdCliente())){
                            new ClienteDao(banco).atualizar(novoCliente);
                            log += "Cliente atualizado!\n"+novoCliente.toString()+"\n\n";
                        }else{
                            log += "Cliente Não atualizado: Não existe Cliente com este id nesta base de dados\n"+novoCliente.toString()+"\n\n";
                        }
                    }catch(java.sql.SQLException e){
                        log += "Cliente não atualizado: "+e+"\n"+novoCliente.toString()+"\n\n";
                    }
                }
                // REMOVER
                else if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("r")){
                    try{
                        if(new ClienteDao(banco).isClienteExiste(novoCliente.getIdCliente())){
                            new ClienteDao(banco).excluir(novoCliente);
                            log += "Cliente removido!\nCliente{idCliente = "+novoCliente.getIdCliente()+"}\n\n"; // ???
                            // Verifica apenas o ID para remover, para não aparecer dados incoerentes, exibi apenas o ID
                            // Remover id = 1 com nome = Bob, Mas na base de dados o id = 1 é João. Remove mesmo assim o João
                        }else{
                            log += "Cliente Não removido: Não existe Cliente com este id nesta base de dados\n"+novoCliente.toString()+"\n\n";
                        }
                    }catch(java.sql.SQLException e){
                        log += "Cliente não removido: "+e+"\n"+novoCliente.toString()+"\n\n";
                    }
                }
                // LER
                else if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("l")){
                    log += "Cliente Lido!\n"+novoCliente.toString()+"\n\n";
                }
        }
        
        // -------------------------------------------------------------------------------
        // ######## SERVICO ###########
        nList = doc.getElementsByTagName("servico");
        Servico novoServico = new Servico();
        for (int i = 0; i < nList.getLength(); i++) {
                Node nNode = nList.item(i);
                //System.out.print("\nElemento corrente : " + nNode.getNodeName());
                if (nNode.getNodeType() != Node.ELEMENT_NODE)
                    continue;
                 
                Element eElement = (Element) nNode;
                // LER DADOS DO CLIENTE
                try{
                    novoServico.setIdServico(Integer.parseInt(eElement.getElementsByTagName("id").item(0).getTextContent()));
                    novoServico.setCodigo(Integer.parseInt(eElement.getElementsByTagName("codigo").item(0).getTextContent()));
                    novoServico.setDescricao(eElement.getElementsByTagName("descricao").item(0).getTextContent());
                    novoServico.setTempoMedio(Integer.parseInt(eElement.getElementsByTagName("tempoMedio").item(0).getTextContent()));
                    novoServico.setValor(Double.parseDouble(eElement.getElementsByTagName("valor").item(0).getTextContent()));
                }catch(NumberFormatException nfe){
                    JOptionPane.showMessageDialog(null, "Elemento Servico possui algum dado inválido");
                    continue;
                }catch(NullPointerException npe){
                    
                }
                
                // INSERIR
                if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("i")){
                    try{
                        new ServicoDao(banco).salvar(novoServico);
                        log += "Serviço inserido!\n"+novoServico.toString()+"\n\n";
                    }catch(java.sql.SQLIntegrityConstraintViolationException e){
                        log += "Serviço não inserido: Já exite Servico com id = "+novoServico.getIdServico()+"\n"+novoServico.toString()+"\n\n";
                    }catch(java.sql.SQLException e){
                        log += "Serviço não inserido: "+e+"\n"+novoServico.toString()+"\n\n";
                    }
                }
                //ATUALIZAR
                else if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("a")){
                    try{
                        if(new ServicoDao(banco).isServicoExiste(novoServico.getIdServico())){
                            new ServicoDao(banco).atualizar(novoServico);
                            log += "Serviço atualizado!\n"+novoServico.toString()+"\n\n";
                        }else{
                            log += "Serviço Não atualizado: Não existe Servico com este id nesta base de dados\n"+novoServico.toString()+"\n\n";
                        }
                    }catch(java.sql.SQLException e){
                        log += "Serviço não atualizado: "+e+"\n"+novoServico.toString()+"\n\n";
                    }
                }
                // REMOVER
                else if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("r")){
                    try{
                        if(new ServicoDao(banco).isServicoExiste(novoServico.getIdServico())){
                            new ServicoDao(banco).excluir(novoServico);
                            log += "Serviço removido!\nServiçoo{idServico = "+novoServico.getIdServico()+"}\n\n"; // ???
                            // Verifica apenas o ID para remover, para não aparecer dados incoerentes, exibi apenas o ID
                            // Remover id = 1 com nome = Bob, Mas na base de dados o id = 1 é João. Remove mesmo assim o João
                        }else{
                            log += "Serviço não removido: Não existe Servico com este id nesta base de dados\n"+novoServico.toString()+"\n\n";
                        }
                    }catch(java.sql.SQLException e){
                        log += "Serviço não removido: "+e+"\n"+novoServico.toString()+"\n\n";
                    }
                }
                // LER
                else if(eElement.getElementsByTagName("op").item(0).getTextContent().equals("l")){
                    log += "Servico Lido!\n"+novoServico.toString()+"\n\n";
                }
        }
        return log;
    }
}
